/*
 * Copyright 2005 Thadeu Lima de Souza Cascardo
 *
 * libgrammatic
 *
 * Translate a grammar to a DFA table, if it is possible, i.e., it's a
 * regular grammar and has no non-determinism.
 *
 */

#include <grammar.h>
#include <dfa.h>

void dfa_gen_add (gpointer key, gpointer val, gpointer data)
{

  symbol_t* left;
  rule_t* right;
  dfa_t* dfa;
  GList* l;

  left = (symbol_t*) key;
  right = (rule_t*) val;
  dfa = (dfa_t*) data;

}

dfa_t* dfa_gen (grammar_t* grammar, symbol_t* start, nextcb cb, gpointer data)
{

  dfa_t* dfa;

  dfa = dfa_new (cb, data, dfa_state_new (start->value, FALSE));

  g_hash_table_foreach (grammar->grammar, dfa_gen_add, dfa);

  return dfa;

}
